# mipt2024f-4-koshelev-a

### Описание задачи

Необходимо создать ректификатор изображений штрих кодов.

**Предполагаемый вход:**

```python
def rectify(
        # Входное изображение, прочитанное с помощью OpenCV
        img_src: np.ndarray,
        
        # Контур кода на исходном изображении в обходе эталона кода
        # начиная с левого нижнего угла против часовой стрелки
        border: np.ndarray,
        
        # Соотношение сторон эталона в формате x_ratio к y_ratio
        x_ratio: int = 1,
        y_ratio: int = 1
) 
```

**Предполагаемый выход:**

Ректифицированное изображение с заданным соотношением сторон и подобранным ректификатором размером.

### Документация



На данный момент API выглядит следующим образом:
1) Конфигурационный файл `config.toml`

```toml
[io]
# Директория, выделенная под данные
dataDir = "data"
# Поддиректория, в которую пишется вывод приложения
outDirSuffix = "out"
# Имя входного файла с данными о преобразовании
tasksJsonFileName = "tasks.json"
```

2) Файл с данными в формате `json`

```json lines
{
  "tasks": [
    {
      // Имя входного файла
      "fileName": "warp.jpg",
      // Соотношение сторон ширина/высота выходного изображения
      "ratio": 1.0,
      // Базовый размер (ширина выходного изображения)
      "dimension": 400,
      // Контур, задающий входные данные (пока четырехугольник)
      "polygon": [
        {
          "x": 1252,
          "y": 1196
        },
        {
          "x": 1668,
          "y": 1496
        },
        {
          "x": 1712,
          "y": 1132
        },
        {
          "x": 1336,
          "y": 828
        }
      ]
    }
  ]
}
```

### Простейшее преобразование перспективы

На данный момент реализовано простейшее преобразование перспективы. Пример работы таков:

<img src="data/warp.jpg" alt="Исходное изображение" style="width: 49%; height: auto;"/>
<img src="data/warp_proc.jpg" alt="Обработанное изображение" style="width: 49%; height: auto;"/>
